<?php
class BlockNewProductz extends Module
{
    private $_html = '';
    private $_postErrors = array();

    function __construct()
    {
        $this->name = 'blocknewproductz';
        $this->tab = 'Blocks';
        $this->version = 1.0;

        parent::__construct();

        $this->displayName = $this->l('New products block (zapalm version)');
        $this->description = $this->l('Add a block that displaying the shop\'s newly added products. In this version you will found a new design and a new option: you can turn on/off the showing random new products.');
    }

    function install()
    {
        if (parent::install() == false OR $this->registerHook('rightColumn') == false OR Configuration::updateValue('NEW_PRODUCTS_NBR', 4) == false OR Configuration::updateValue('NEW_PRODUCTS_RANDOM', 1) == false)
            return false;
        return true;
    }

	public function getContent()
	{
		$output = '<h2>'.$this->displayName.'</h2>';
		if (Tools::isSubmit('submitBlockNewProducts'))
		{
			if (!$productNbr = Tools::getValue('productNbr') OR empty($productNbr))
				$output .= '<div class="alert error">'.$this->l('You should fill the "products displayed" field').'</div>';
			elseif (intval($productNbr) == 0)
				$output .= '<div class="alert error">'.$this->l('Invalid number of products.').'</div>';
			else
			{
				Configuration::updateValue('NEW_PRODUCTS_NBR', intval($productNbr));
				Configuration::updateValue('NEW_PRODUCTS_RANDOM', intval(Tools::getValue('NEW_PRODUCTS_RANDOM')));
				$output .= '<div class="conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l('Confirmation').'" />'.$this->l('Settings updated').'</div>';
			}
		}
		return $output.$this->displayForm();
	}

	public function displayForm()
	{
		global $cookie;
		
		$output = '
			<fieldset style="width: 400px"><legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Settings').'</legend>
				<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
					<label>'.$this->l('Products displayed').'</label>
					<div class="margin-form">
						<input type="text" name="productNbr" value="'.intval(Configuration::get('NEW_PRODUCTS_NBR')).'" />
						<p class="clear">'.$this->l('Set the number of products to be displayed in this block').'</p>
					</div>
					<label>'.$this->l('Show new products randomly').'</label>
					<div class="margin-form">
						<input type="checkbox" name="NEW_PRODUCTS_RANDOM"  value="1" '.(Configuration::get('NEW_PRODUCTS_RANDOM') ? 'checked="checked"' : '').' />
						<p class="clear">'.$this->l('Check it, if you whant to show new products randomly').'</p>
					</div>
					<center><input type="submit" name="submitBlockNewProducts" value="'.$this->l('Save').'" class="button" /></center>
				</form>
			</fieldset>
			<br class="clear">
		';
		
		$iso_code = Db::getInstance()->ExecuteS('SELECT `iso_code` FROM `ps_lang` WHERE `active`=1 AND `id_lang`='.$cookie->id_lang);
		$output.= '
				<fieldset style="width: 400px;">
					<legend><img src="../img/admin/manufacturers.gif" /> '.$this->l('Module info').'</legend>
					<div id="dev_div">
						<span><b>'.$this->l('Version').':</b> v1.0</span><br>
						<span><b>'.$this->l('License').':</b> free and open</span><br>
						<span><b>'.$this->l('Forums').':</b> <a class="link" href="http://www.prestashop.com/forums/viewthread/66896/" target="_blank">'.$this->l('english').'</a>, <a class="link" href="http://prestadev.ru/forum/tema-1512.html" target="_blank">'.$this->l('russian').'</a></span><br>
						<span><b>'.$this->l('Website').':</b> <a class="link" href="http://modulez.ru'.($iso_code[0]['iso_code'] == 'ru' ? '' : '/en/').' " target="_blank">modulez.ru'.($iso_code[0]['iso_code'] == 'ru' ? '' : '/en/').'</a><br>
						<span><b>'.$this->l('Contact').':</b> <a class="link" href="mailto:zapalm@yandex.ru" target="_blank">zapalm@yandex.ru</a><br><span style="font-style:italic">('.$this->l('please, send me a message in russian or english only').')</span></span><br>
						<br>
						<span style="font-style:italic">'.$this->l('Thank you for the using this module').'</span>&nbsp;&nbsp;<img src="../modules/'.$this->name.'/zapalm24x24.jpg" />			
					</div>
				</fieldset>
				<br class="clear">
		';		
		
		return $output;
	}
	
	public function getNewProducts($id_lang, $nbProducts = 4, $orderBy = NULL, $orderWay = NULL, $random = true, $randomNumberProducts = 4)
	{
		global $cookie;

		if (empty($orderBy) || $orderBy == 'position') $orderBy = 'date_add';
		if (empty($orderWay)) $orderWay = 'DESC';
		if ($orderBy == 'id_product' OR $orderBy == 'price' OR $orderBy == 'date_add')
			$orderByPrefix = 'p';
		elseif ($orderBy == 'name')
		$orderByPrefix = 'pl';
		if (!Validate::isOrderBy($orderBy) OR !Validate::isOrderWay($orderWay))
			die(Tools::displayError());

		$sql = '
		SELECT p.*, pl.`description`, pl.`description_short`, pl.`link_rewrite`, pl.`meta_description`, pl.`meta_keywords`, pl.`meta_title`, pl.`name`, p.`ean13`,
			i.`id_image`, il.`legend`, t.`rate`, m.`name` AS manufacturer_name, DATEDIFF(p.`date_add`, DATE_SUB(NOW(), INTERVAL '.(Validate::isUnsignedInt(Configuration::get('PS_NB_DAYS_NEW_PRODUCT')) ? Configuration::get('PS_NB_DAYS_NEW_PRODUCT') : 20).' DAY)) > 0 AS new, 
			(p.`price` * ((100 + (t.`rate`))/100) - IF((DATEDIFF(`reduction_from`, CURDATE()) <= 0 AND DATEDIFF(`reduction_to`, CURDATE()) >=0) OR `reduction_from` = `reduction_to`, IF(`reduction_price` > 0, `reduction_price`, (p.`price` * ((100 + (t.`rate`))/100) * `reduction_percent` / 100)),0)) AS orderprice 
		FROM `'._DB_PREFIX_.'product` p
		LEFT JOIN `'._DB_PREFIX_.'product_lang` pl ON (p.`id_product` = pl.`id_product` AND pl.`id_lang` = '.intval($id_lang).')
		LEFT JOIN `'._DB_PREFIX_.'image` i ON (i.`id_product` = p.`id_product` AND i.`cover` = 1)
		LEFT JOIN `'._DB_PREFIX_.'image_lang` il ON (i.`id_image` = il.`id_image` AND il.`id_lang` = '.intval($id_lang).')
		LEFT JOIN `'._DB_PREFIX_.'tax` t ON (t.`id_tax` = p.`id_tax`)
		LEFT JOIN `'._DB_PREFIX_.'manufacturer` m ON (m.`id_manufacturer` = p.`id_manufacturer`)
		WHERE p.`active` = 1
		AND p.`date_add` > DATE_SUB(NOW(), INTERVAL '.(Validate::isUnsignedInt(Configuration::get('PS_NB_DAYS_NEW_PRODUCT')) ? Configuration::get('PS_NB_DAYS_NEW_PRODUCT') : 20).' DAY)
		AND p.`id_product` IN (
			SELECT cp.`id_product`
			FROM `'._DB_PREFIX_.'category_group` cg
			LEFT JOIN `'._DB_PREFIX_.'category_product` cp ON (cp.`id_category` = cg.`id_category`)
			WHERE cg.`id_group` '.(!$cookie->id_customer ?  '= 1' : 'IN (SELECT id_group FROM '._DB_PREFIX_.'customer_group WHERE id_customer = '.intval($cookie->id_customer).')').'
		)';
    
		if ($random === true)
		{
			$sql .= ' ORDER BY RAND()';
			$sql .= ' LIMIT 0, '.intval($randomNumberProducts);
    }
		else
		{
			$sql .= ' ORDER BY '.(isset($orderByPrefix) ? $orderByPrefix.'.' : '').'`'.pSQL($orderBy).'` '.pSQL($orderWay).'
			LIMIT 0, '.intval($nbProducts);
		}    
    
    $result = Db::getInstance()->ExecuteS($sql);

    if ($orderBy == 'price') {
			Tools::orderbyPrice($result, $orderWay);
    }
    
		if (!$result)
			return false;

		return Product::getProductsProperties(intval($id_lang), $result);
	}	

	function hookRightColumn($params)
	{
		global $smarty;
		
		$nb = intval(Configuration::get('NEW_PRODUCTS_NBR'));
		if (intval(Configuration::get('NEW_PRODUCTS_RANDOM'))) {
      $newProducts = $this->getNewProducts(intval($params['cookie']->id_lang), ($nb ? $nb : 4), NULL, NULL, true, ($nb ? $nb : 4));
    }
    else {
      $newProducts = Product::getNewProducts(intval($params['cookie']->id_lang), 0, ($nb ? $nb : 4));
    }
    
		$smarty->assign(array('new_products' => $newProducts, 'mediumSize' => Image::getSize('medium')));

		return $this->display(__FILE__, 'blocknewproductz.tpl');
	}
	
	function hookLeftColumn($params)
	{
		return $this->hookRightColumn($params);
	}
}

?>